/******************************************************************************\

          This file is part of the C! library.  A.K.A the cbang library.

              Copyright (c) 2003-2012, Cauldron Development LLC
                 Copyright (c) 2003-2012, Stanford University
                             All rights reserved.

        The C! library is free software: you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public License
        as published by the Free Software Foundation, either version 2.1 of
        the License, or (at your option) any later version.

        The C! library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with the C! library.  If not, see
        <http://www.gnu.org/licenses/>.

        In addition, BSD licensing may be granted on a case by case basis
        by written permission from at least one of the copyright holders.
        You may request written permission by emailing the authors.

                For information regarding this software email:
                               Joseph Coffland
                        joseph@cauldrondevelopment.com

\******************************************************************************/

#ifndef CBANG_IPRANGE_SET_H
#define CBANG_IPRANGE_SET_H

#include <cbang/net/IPAddressRange.h>

#include <vector>
#include <string>

namespace cb {
  /// Maintains a set if IP address ranges
  class IPRangeSet {
    typedef std::vector<IPAddressRange> rangeSet_t;
    rangeSet_t rangeSet;

  public:
    bool empty() const {return rangeSet.empty();}

    void insert(const std::string &spec);
    void insert(const IPAddressRange &range);
    bool contains(const IPAddress &ip) const;
  };
}

#endif // CBANG_IPRANGE_SET_H

