/******************************************************************************\

          This file is part of the C! library.  A.K.A the cbang library.

              Copyright (c) 2003-2012, Cauldron Development LLC
                 Copyright (c) 2003-2012, Stanford University
                             All rights reserved.

        The C! library is free software: you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public License
        as published by the Free Software Foundation, either version 2.1 of
        the License, or (at your option) any later version.

        The C! library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with the C! library.  If not, see
        <http://www.gnu.org/licenses/>.

        In addition, BSD licensing may be granted on a case by case basis
        by written permission from at least one of the copyright holders.
        You may request written permission by emailing the authors.

                For information regarding this software email:
                               Joseph Coffland
                        joseph@cauldrondevelopment.com

\******************************************************************************/

#ifndef CBANG_KEY_PAIR_H
#define CBANG_KEY_PAIR_H

#include <iostream>

typedef struct dsa_st DSA;

namespace cb {
  class KeyPair {
    DSA *key;

  public:
    KeyPair() : key(0) {}
    ~KeyPair();

    void generate();

    bool hasPublic() const;
    bool hasPrivate() const;

    const std::string sign(const std::string &s) const;

    std::istream &read(std::istream &stream);
    std::ostream &write(std::ostream &stream) const;
  };

  inline std::istream &operator>>(std::istream &stream, KeyPair &key) {
    return key.read(stream);
  }

  inline std::ostream &operator<<(std::ostream &stream, const KeyPair &key) {
    return key.write(stream);
  }
}

#endif // CBANG_KEY_PAIR_H

