/******************************************************************************\

          This file is part of the C! library.  A.K.A the cbang library.

              Copyright (c) 2003-2012, Cauldron Development LLC
                 Copyright (c) 2003-2012, Stanford University
                             All rights reserved.

        The C! library is free software: you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public License
        as published by the Free Software Foundation, either version 2.1 of
        the License, or (at your option) any later version.

        The C! library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with the C! library.  If not, see
        <http://www.gnu.org/licenses/>.

        In addition, BSD licensing may be granted on a case by case basis
        by written permission from at least one of the copyright holders.
        You may request written permission by emailing the authors.

                For information regarding this software email:
                               Joseph Coffland
                        joseph@cauldrondevelopment.com

\******************************************************************************/

#ifndef CBANG_MD5_H
#define CBANG_MD5_H

#include <string>

namespace cb {
  class MD5 {
    struct private_t;
    private_t *p;

    unsigned char digest[16];
    bool finalized;

  public:
    MD5(const std::string &s = std::string());
    ~MD5();

    void add(const std::string &s);
    void add(const char *s, unsigned n);
    template <typename T>
    void add(const T &x) {add((const char *)&x, sizeof(T));}

    void getDigest(unsigned char digest[16]);
    std::string toString() const;
    std::string toString();
    void finalize();
    void reset();

    static std::string hash(const std::string &s);
  };
}

#endif // CBANG_MD5_H
