/******************************************************************************\

    OpenSCAM is an Open-Source CAM software.
    Copyright (C) 2011-2012 Joseph Coffland <joseph@cauldrondevelopment.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\******************************************************************************/

#include "Builder.h"

#include <cbang/Exception.h>

using namespace std;
using namespace cb;
using namespace OpenSCAM;


void Builder::addFromString(const char *data, unsigned length) {
  GError *err = 0;
  if (!gtk_builder_add_from_string(builder, data, length, &err))
    THROWS(err->message);
}


void Builder::connect(void *data) {
  gtk_builder_connect_signals(builder, data);
}


void Builder::connect(GObject *object, const string &signal,
                      GCallback callback, void *data) {
  g_signal_connect(object, signal.c_str(), callback, data);
}


void Builder::connect(const string &object, const string &signal,
                      GCallback callback, void *data) {
  connect(G_OBJECT(get<GtkWidget>(object)), signal, callback, (void *)data);
}
