/******************************************************************************\

    OpenSCAM is an Open-Source CAM software.
    Copyright (C) 2011-2012 Joseph Coffland <joseph@cauldrondevelopment.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\******************************************************************************/

#ifndef OPENSCAM_DIALOG_H
#define OPENSCAM_DIALOG_H

#include <gtk/gtk.h>

#include <string>


namespace OpenSCAM {
  class Builder;

  class Dialog {
  protected:
    const char *name;
    GtkDialog *dialog;

  public:
    Dialog(Builder &builder, const char *name);
    virtual ~Dialog() {}

    void setTitle(const std::string &title);
    void setTransientFor(GtkWindow *parent);
    GtkWindow *getWindow() {return GTK_WINDOW(dialog);}

    virtual void show();
    virtual void hide();
    virtual int run();

    virtual void accept();
    virtual void cancel();
    virtual void response(int id);

    void on_ok(GtkWidget *widget);
    void on_cancel(GtkWidget *widget);
    bool on_delete(GtkWidget *widget, GdkEvent *event);
    void on_response(GtkDialog *dialog, gint id);
  };
}

#endif // OPENSCAM_DIALOG_H

