/******************************************************************************\

    OpenSCAM is an Open-Source CAM software.
    Copyright (C) 2011-2012 Joseph Coffland <joseph@cauldrondevelopment.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\******************************************************************************/

#ifndef OPENSCAM_FILE_DIALOG_H
#define OPENSCAM_FILE_DIALOG_H

#include "Dialog.h"

#include <string>


namespace OpenSCAM {
  class GUIApp;

  class FileDialog : public Dialog {
    GUIApp &app;
    std::string filename;

  public:
    FileDialog(GUIApp &app);

    void setFilename(const std::string &filename);
    void setCurrentFolder(const std::string &path);
    std::string getFilename() const;
    void confirmOverwrite(bool x);

    void setFilter(const std::string &name, const std::string &patterns);
    void addFilter(const std::string &name, const std::string &patterns);
    void clearFilters();

    bool open(GtkWindow *parent, const std::string &name = "",
              const std::string &filters = "");
    bool save(GtkWindow *parent, const std::string &name = "",
              const std::string &filters = "");

    // From Dialog
    void accept();
  };
}

#endif // OPENSCAM_FILE_DIALOG_H

