/******************************************************************************\

    OpenSCAM is an Open-Source CAM software.
    Copyright (C) 2011-2012 Joseph Coffland <joseph@cauldrondevelopment.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\******************************************************************************/

#ifndef OPENSCAM_GTKHELPER_H
#define OPENSCAM_GTKHELPER_H

#include <cbang/util/DefaultCatch.h>

#include <gtk/gtk.h>


#define GTK_SIGNAL0B(name, className)                       \
  extern "C" G_MODULE_EXPORT bool name(className *obj) {    \
    try {return obj->name();} CBANG_CATCH_ERROR;            \
    return false;                                           \
  }

#define GTK_SIGNAL1B(name, arg1Type, className)                         \
  extern "C" G_MODULE_EXPORT bool name(arg1Type arg1, className *obj) { \
    try {return obj->name(arg1);} CBANG_CATCH_ERROR;                    \
    return false;                                                       \
  }

#define GTK_SIGNAL2B(name, arg1Type, arg2Type, className)               \
  extern "C" G_MODULE_EXPORT bool name(arg1Type arg1, arg2Type arg2,    \
                                       className *obj) {                \
    try {return obj->name(arg1, arg2);} CBANG_CATCH_ERROR;              \
    return false;                                                       \
  }

#define GTK_SIGNAL3B(name, arg1Type, arg2Type, arg3Type, className)     \
  extern "C" G_MODULE_EXPORT bool name(arg1Type arg1, arg2Type arg2,    \
                                       arg3Type arg3,                   \
                                       className *obj) {                \
    try {return obj->name(arg1, arg2, arg3);} CBANG_CATCH_ERROR;        \
    return false;                                                       \
  }

#define GTK_SIGNAL4B(name, arg1Type, arg2Type, arg3Type, arg4Type, className) \
  extern "C" G_MODULE_EXPORT bool name(arg1Type arg1, arg2Type arg2,    \
                                       arg3Type arg3, arg4Type arg4,    \
                                       className *obj) {                \
    try {return obj->name(arg1, arg2, arg3, arg4);} CBANG_CATCH_ERROR;  \
    return false;                                                       \
  }

#define GTK_SIGNAL0V(name, className)                           \
  extern "C" G_MODULE_EXPORT void name(className *obj) {        \
    try {obj->name();} CBANG_CATCH_ERROR;                       \
  }

#define GTK_SIGNAL1V(name, arg1Type, className)                         \
  extern "C" G_MODULE_EXPORT void name(arg1Type arg1, className *obj) { \
    try {obj->name(arg1);} CBANG_CATCH_ERROR;                           \
  }

#define GTK_SIGNAL2V(name, arg1Type, arg2Type, className)               \
  extern "C" G_MODULE_EXPORT void name(arg1Type arg1, arg2Type arg2,    \
                                       className *obj) {                \
    try {obj->name(arg1, arg2);} CBANG_CATCH_ERROR;                     \
  }

#define GTK_SIGNAL3V(name, arg1Type, arg2Type, arg3Type, className)     \
  extern "C" G_MODULE_EXPORT void name(arg1Type arg1, arg2Type arg2,    \
                                       arg3Type arg3,                   \
                       className *obj) {                                \
    try {obj->name(arg1, arg2, arg3);} CBANG_CATCH_ERROR;               \
  }

#define GTK_SIGNAL4V(name, arg1Type, arg2Type, arg3Type, arg4Type, className) \
  extern "C" G_MODULE_EXPORT void name(arg1Type arg1, arg2Type arg2,    \
                                       arg3Type arg3, arg4Type arg4,    \
                                       className *obj) {                \
    try {obj->name(arg1, arg2, arg3, arg4);} CBANG_CATCH_ERROR;         \
  }

#endif // OPENSCAM_GTKHELPER_H

