/******************************************************************************\

    OpenSCAM is an Open-Source CAM software.
    Copyright (C) 2011-2012 Joseph Coffland <joseph@cauldrondevelopment.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\******************************************************************************/

#ifndef OPENSCAM_GTKSMART_POINTER_H
#define OPENSCAM_GTKSMART_POINTER_H

#include <cbang/SmartPointer.h>

#include <gtk/gtk.h>

namespace OpenSCAM {
  template <typename T>
  class GTKSmartPointer : public
  cb::SmartPointer<T, cb::RefCounter<T, cb::SPFunc<g_object_unref> > > {
    typedef
    cb::SmartPointer<T, cb::RefCounter<T, cb::SPFunc<g_object_unref> > > SuperT;

  public:
    GTKSmartPointer(const GTKSmartPointer<T> &smartPtr) :
      SuperT(smartPtr) {}

    GTKSmartPointer(T *ptr = 0, cb::RefCounterBase *refCounter = 0) :
      SuperT(ptr, refCounter) {}
  };
}

#endif // OPENSCAM_GTKSMART_POINTER_H

