/******************************************************************************\

    OpenSCAM is an Open-Source CAM software.
    Copyright (C) 2011-2012 Joseph Coffland <joseph@cauldrondevelopment.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\******************************************************************************/

#ifndef OPENSCAM_GTK_OBJECT_SET_H
#define OPENSCAM_GTK_OBJECT_SET_H

#include <map>
#include <string>

typedef struct _GObject GObject;
typedef struct _GtkBuilder GtkBuilder;

namespace OpenSCAM {
  class Builder;

  class GtkObjectSet : public std::map<std::string, GObject *> {
  public:
    GtkObjectSet(Builder &builder, const std::string &suffix);

    GObject *get(const std::string &name) const;
    GObject *operator[](const std::string &name) const {return get(name);}
  };
}

#endif // OPENSCAM_GTK_OBJECT_SET_H

