/******************************************************************************\

    OpenSCAM is an Open-Source CAM software.
    Copyright (C) 2011-2012 Joseph Coffland <joseph@cauldrondevelopment.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\******************************************************************************/

#include "GtkObserver.h"

#include <openscam/value/StringFormatter.h>

#include <cbang/Exception.h>

using namespace std;
using namespace cb;
using namespace OpenSCAM;


GtkObserver::GtkObserver(GtkWidget *widget) :
  FormattedObserver(0), widget(widget) {

  GType type = G_OBJECT_TYPE(widget);
  const char *text = 0;

  if (type == GTK_TYPE_LABEL) text = gtk_label_get_label((GtkLabel *)widget);
  else THROWS("Unsupported Gtk type " << type);

  formatter = new StringFormatter(text);
}


void GtkObserver::formattedUpdate(const string &name, const string &value) {
  GType type = G_OBJECT_TYPE(widget);

  if (type == GTK_TYPE_LABEL)
    gtk_label_set_markup((GtkLabel *)widget, value.c_str());
}
