/******************************************************************************\

    OpenSCAM is an Open-Source CAM software.
    Copyright (C) 2011-2012 Joseph Coffland <joseph@cauldrondevelopment.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\******************************************************************************/

#include "Axes.h"

using namespace std;
using namespace OpenSCAM;


const char *Axes::AXES = "XYZABCUVW";


double Axes::distance(const Axes &o) const {
  // TODO distance using all axes
  return getVector3D().distance(o.getVector3D());
}


ostream &Axes::print(ostream &stream) const {
  for (const char *axes = AXES; *axes; axes++) {
    if (axes != AXES) stream << ", ";
    stream << *axes << '=' << get(*axes);
  }

  return stream;
}
