/******************************************************************************\

    OpenSCAM is an Open-Source CAM software.
    Copyright (C) 2011-2012 Joseph Coffland <joseph@cauldrondevelopment.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\******************************************************************************/

#include "Machine.h"

#include <openscam/cutsim/Move.h>

#include <cbang/log/Logger.h>

using namespace cb;
using namespace OpenSCAM;


void Machine::makeMove(MoveType type, const Axes &newPos) {
  move(Move(type, position, newPos, time, tool, feed, speed, -1));
}


void Machine::start() {
  position = Axes();
  time = 0;
  distance = 0;
}


void Machine::move(const Move &move) {
  position = move.getEnd();
  distance += move.getDistance();
  time += move.getTime();

  LOG_INFO(3, "Machine: Move to " << move.getEndPt());
}


void Machine::dwell(double time) {
  this->time += time;

  LOG_INFO(3, "Machine: Dwell for " << time << " seconds");
}
