#ifndef OPENSCAM_TPL_ARGUMENTS_H
#define OPENSCAM_TPL_ARGUMENTS_H

#include "type/Value.h"

#include <vector>


namespace OpenSCAM {
  namespace TPL {
    class Arguments : public std::vector<cb::SmartPointer<Value> > {
    public:
      typedef std::vector<cb::SmartPointer<Value> > Super_T;
      Arguments(unsigned size = 0) : Super_T(size) {}

      const cb::SmartPointer<Value> &get(unsigned i) const;
      int32_t getInteger(unsigned i) const {return get(i)->toInteger();}
      double getFloat(unsigned i) const {return get(i)->toFloat();}
      const std::string &getString(unsigned i) const
      {return get(i)->toString();}
      bool getBool(unsigned i) const {return get(i)->toBool();}
      const std::vector<cb::SmartPointer<Value> > &getVector(unsigned i) const
      {return get(i)->toVector();}
    };
  }
}

#endif // OPENSCAM_TPL_ARGUMENTS_H

