#ifndef OPENSCAM_TPL_EVALUATOR_H
#define OPENSCAM_TPL_EVALUATOR_H

#include "ast/ASTEvaluator.h"
#include "TPLID.h"


namespace OpenSCAM {
  namespace TPL {
    class Context;

    class Evaluator : public ASTEvaluator, public TPLID {
      Context &ctx;

    public:
      Evaluator(Context &ctx) : ctx(ctx) {}

      cb::SmartPointer<Value> eval(TPLID op,
                                   const cb::SmartPointer<Value> &left,
                                   const cb::SmartPointer<Value> &right);

      // From ASTEvaluator
      cb::SmartPointer<Value> eval(BinaryExpr &);
      cb::SmartPointer<Value> eval(CallExpr &);
      cb::SmartPointer<Value> eval(QuotedExpr &);
      cb::SmartPointer<Value> eval(SliceExpr &);
      cb::SmartPointer<Value> eval(UnaryExpr &);
      cb::SmartPointer<Value> eval(VariableExpr &);
      cb::SmartPointer<Value> eval(VectorExpr &);

      cb::SmartPointer<Value> eval(Constant &);
    };
  }
}

#endif // OPENSCAM_TPL_EVALUATOR_H

