#ifndef OPENSCAM_TPL_LEXER_H
#define OPENSCAM_TPL_LEXER_H

#include "TPLID.h"

#include <cbang/parse/Tokenizer.h>

#include <map>
#include <string>

namespace OpenSCAM {
  namespace TPL {
    class Lexer : public cb::Tokenizer<TPLID> {
      typedef std::map<std::string, TPLID> keywords_t;
      keywords_t keywords;

    public:
      Lexer(cb::Scanner &scanner);

      void doID();
      void doNumber(bool dot);
      void doString();
      void doLineComment();
      void doComment();

      // From cb::Tokenizer
      void next();
    };
  }
}

#endif // OPENSCAM_TPL_LEXER_H

