#ifndef OPENSCAM_TPL_LOADER_H
#define OPENSCAM_TPL_LOADER_H

#include "Module.h"

#include <cbang/SmartPointer.h>

#include <map>
#include <vector>
#include <string>


namespace OpenSCAM {
  namespace TPL {
    class Loader {
      typedef std::map<std::string, cb::SmartPointer<Module> > modules_t;
      modules_t modules;

      typedef std::vector<std::string> paths_t;
      paths_t paths;

    public:
      Loader();

      void add(const cb::SmartPointer<Module> &module);
      const cb::SmartPointer<Module> &find(const std::string &path) const;
      cb::SmartPointer<Module> load(const std::string &name,
                                    const std::string &cwd);

    protected:
      cb::SmartPointer<Module> tryLoad(const std::string &name,
                                       const std::string &path);
    };
  }
}

#endif // OPENSCAM_TPL_LOADER_H

