/******************************************************************************\

    OpenSCAM is an Open-Source CAM software.
    Copyright (C) 2011-2012 Joseph Coffland <joseph@cauldrondevelopment.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\******************************************************************************/

#ifndef CBANG_ENUM_EXPAND
#ifndef OPENSCAM_TPL_ID_H
#define OPENSCAM_TPL_ID_H

#define CBANG_ENUM_NAME TPLID
#define CBANG_ENUM_NAMESPACE OpenSCAM
#define CBANG_ENUM_NAMESPACE2 TPL
#define CBANG_ENUM_PREFIX 6
#define CBANG_ENUM_PATH openscam/tpl
#include <cbang/enum/MakeEnumeration.def>

#endif // OPENSCAM_TPL_ID_H
#else // CBANG_ENUM_EXPAND

CBANG_ENUM_EXPAND(TPLID_EOF,           0)

CBANG_ENUM_EXPAND(TPLID_ID,            1)
CBANG_ENUM_EXPAND(TPLID_STRING,        2)
CBANG_ENUM_EXPAND(TPLID_NUMBER,        3)

CBANG_ENUM_EXPAND(TPLID_OPAREN,        4)
CBANG_ENUM_EXPAND(TPLID_CPAREN,        5)
CBANG_ENUM_EXPAND(TPLID_OBRACKET,      6)
CBANG_ENUM_EXPAND(TPLID_CBRACKET,      7)
CBANG_ENUM_EXPAND(TPLID_OBRACE,        8)
CBANG_ENUM_EXPAND(TPLID_CBRACE,        9)

CBANG_ENUM_EXPAND(TPLID_COMMA,         10)
CBANG_ENUM_EXPAND(TPLID_COLON,         11)
CBANG_ENUM_EXPAND(TPLID_SEMI,          12)
CBANG_ENUM_EXPAND(TPLID_DOT,           13)

CBANG_ENUM_EXPAND(TPLID_ASSIGN,        14)
CBANG_ENUM_EXPAND(TPLID_ADD_ASSIGN,    15)
CBANG_ENUM_EXPAND(TPLID_SUB_ASSIGN,    16)
CBANG_ENUM_EXPAND(TPLID_DIV_ASSIGN,    17)
CBANG_ENUM_EXPAND(TPLID_MUL_ASSIGN,    18)
CBANG_ENUM_EXPAND(TPLID_MOD_ASSIGN,    19)

CBANG_ENUM_EXPAND(TPLID_ADD,           20)
CBANG_ENUM_EXPAND(TPLID_SUB,           21)
CBANG_ENUM_EXPAND(TPLID_DIV,           22)
CBANG_ENUM_EXPAND(TPLID_MUL,           23)
CBANG_ENUM_EXPAND(TPLID_MOD,           24)

CBANG_ENUM_EXPAND(TPLID_AND,           25)
CBANG_ENUM_EXPAND(TPLID_OR,            26)

CBANG_ENUM_EXPAND(TPLID_LESS,          27)
CBANG_ENUM_EXPAND(TPLID_LESS_EQUAL,    28)
CBANG_ENUM_EXPAND(TPLID_GREATER,       29)
CBANG_ENUM_EXPAND(TPLID_GREATER_EQUAL, 30)
CBANG_ENUM_EXPAND(TPLID_EQUAL,         31)
CBANG_ENUM_EXPAND(TPLID_NOT_EQUAL,     32)

CBANG_ENUM_EXPAND(TPLID_NOT,           33)
CBANG_ENUM_EXPAND(TPLID_AMPERSAND,     34)
CBANG_ENUM_EXPAND(TPLID_BAR,           35)
CBANG_ENUM_EXPAND(TPLID_ETC,           36)

CBANG_ENUM_EXPAND(TPLID_IMPORT,        100)
CBANG_ENUM_EXPAND(TPLID_FROM,          101)
CBANG_ENUM_EXPAND(TPLID_AS,            102)
CBANG_ENUM_EXPAND(TPLID_CONSTANT,      103)
CBANG_ENUM_EXPAND(TPLID_FUNCTION,      104)
CBANG_ENUM_EXPAND(TPLID_IF,            105)
CBANG_ENUM_EXPAND(TPLID_ELSE,          106)
CBANG_ENUM_EXPAND(TPLID_FOR,           107)
CBANG_ENUM_EXPAND(TPLID_WHILE,         108)
CBANG_ENUM_EXPAND(TPLID_DO,            109)
CBANG_ENUM_EXPAND(TPLID_SWITCH,        110)
CBANG_ENUM_EXPAND(TPLID_CASE,          111)
CBANG_ENUM_EXPAND(TPLID_BREAK,         112)
CBANG_ENUM_EXPAND(TPLID_DEFAULT,       113)
CBANG_ENUM_EXPAND(TPLID_CONTINUE,      114)
CBANG_ENUM_EXPAND(TPLID_RETURN,        115)
CBANG_ENUM_EXPAND(TPLID_TRUE,          116)
CBANG_ENUM_EXPAND(TPLID_FALSE,         117)
CBANG_ENUM_EXPAND(TPLID_NULL,          118)

CBANG_ENUM_EXPAND(TPLID_PROGRAM,       200)
CBANG_ENUM_EXPAND(TPLID_BLOCK,         201)
CBANG_ENUM_EXPAND(TPLID_NAME,          202)
CBANG_ENUM_EXPAND(TPLID_ARGUMENT,      203)
CBANG_ENUM_EXPAND(TPLID_LIST,          204)
CBANG_ENUM_EXPAND(TPLID_SLICE,         205)
CBANG_ENUM_EXPAND(TPLID_VECTOR,        206)
CBANG_ENUM_EXPAND(TPLID_QUOTED_EXPR,   207)
CBANG_ENUM_EXPAND(TPLID_CALL,          208)
CBANG_ENUM_EXPAND(TPLID_VARIABLE_EXPR, 209)
CBANG_ENUM_EXPAND(TPLID_BOOL,          210)
CBANG_ENUM_EXPAND(TPLID_VARIABLE,      211)
CBANG_ENUM_EXPAND(TPLID_MODULE,        212)
CBANG_ENUM_EXPAND(TPLID_INTEGER,       213)
CBANG_ENUM_EXPAND(TPLID_FLOAT,         214)

#define FIRST_KEYWORD TPLID_IMPORT
#define LAST_KEYWORD TPLID_NULL

#endif // CBANG_ENUM_EXPAND
