#ifndef OPENSCAM_TPL_ASTEVALUATOR_H
#define OPENSCAM_TPL_ASTEVALUATOR_H

#include <cbang/Exception.h>
#include <cbang/SmartPointer.h>

#include <openscam/tpl/type/Value.h>


namespace OpenSCAM {
  namespace TPL {
    class Value;

#define OPENSCAM_TPL_AST(name) class name;
#include "AST.def"
#undef OPENSCAM_TPL_AST

    class ASTEvaluator {
    public:
      void notYetImplemented() const
      {THROW("Not yet implemented in ASTEvaluator");}

#define OPENSCAM_TPL_AST(name) \
      virtual cb::SmartPointer<Value> eval(name &) {    \
        notYetImplemented();                            \
        return 0;                                         \
      }
#include "AST.def"
#undef OPENSCAM_TPL_AST
    };
  }
}

#endif // OPENSCAM_TPL_ASTEVALUATOR_H

