#ifndef OPENSCAM_TPL_ASTINTERPRETER_H
#define OPENSCAM_TPL_ASTINTERPRETER_H

#include <cbang/Exception.h>
#include <cbang/SmartPointer.h>

#include "../type/Value.h"

namespace OpenSCAM {
  namespace TPL {
    class Value;

#define OPENSCAM_TPL_AST(name) class name;
#include "AST.def"
#undef OPENSCAM_TPL_AST

    class ASTInterpreter {
    public:
      void notYetImplemented() const
      {THROW("Not yet implemented in ASTInterpreter");}

#define OPENSCAM_TPL_AST(name) \
      virtual void interpret(name &) {notYetImplemented();}
#include "AST.def"
#undef OPENSCAM_TPL_AST
    };
  }
}

#endif // OPENSCAM_TPL_ASTINTERPRETER_H

