#ifndef OPENSCAM_TPL_ASTNODE_H
#define OPENSCAM_TPL_ASTNODE_H

#include <cbang/SmartPointer.h>
#include <cbang/parse/ASTNode.h>

#include "ASTVisitor.h"
#include "ASTEvaluator.h"
#include "ASTInterpreter.h"

#include "../TPLID.h"
#include "../Lexer.h"
#include "../type/Value.h"


namespace OpenSCAM {
  namespace TPL {
    class Value;

    class ASTNode : public cb::ASTNode<TPLID>, public TPLID {
    public:
      ASTNode(TPLID type = TPLID_EOF) : cb::ASTNode<TPLID>(type) {}

      virtual void visit(ASTVisitor &visitor) = 0;
      virtual void interpret(ASTInterpreter &i) = 0;
      virtual cb::SmartPointer<Value> eval(ASTEvaluator &e) = 0;
    };
  }
}

#define OPENSCAM_TPL_AST_NODE_VISITORS \
  void visit(ASTVisitor &v) {v.visit(*this);}   \
  void interpret(ASTInterpreter &i) {i.interpret(*this);} \
  cb::SmartPointer<Value> eval(ASTEvaluator &e) {return e.eval(*this);}


#endif // OPENSCAM_TPL_ASTNODE_H

