#ifndef OPENSCAM_TPL_ARGUMENT_DECL_H
#define OPENSCAM_TPL_ARGUMENT_DECL_H

#include "VariableDecl.h"
#include "Expression.h"

#include <string>


namespace OpenSCAM {
  namespace TPL {
    class ArgumentDecl : public VariableDecl {
      cb::SmartPointer<Expression> expr;

    public:
      ArgumentDecl(const std::string &name) :
        VariableDecl(name) {setType(TPLID_ARGUMENT);}

      const cb::SmartPointer<Expression> &getDefault() const {return expr;}
      void setDefault(const cb::SmartPointer<Expression> &expr)
      {this->expr = expr;}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_ARGUMENT_DECL_H

