#ifndef OPENSCAM_TPL_ASSIGN_STMT_H
#define OPENSCAM_TPL_ASSIGN_STMT_H

#include "Statement.h"
#include "Expression.h"
#include "Declaration.h"
#include "VariableExpr.h"

#include <string>


namespace OpenSCAM {
  namespace TPL {
    class AssignStmt : public Statement {
    public:
      typedef std::vector<cb::SmartPointer<Expression> > indices_t;

    private:
      cb::SmartPointer<VariableExpr> var;
      indices_t indices;
      cb::SmartPointer<Expression> expr;
      bool global;

    public:
      AssignStmt(TPLID type, const cb::SmartPointer<VariableExpr> &var,
                 const indices_t &indices,
                 const cb::SmartPointer<Expression> &expr, bool global) :
        Statement(type), var(var), indices(indices), expr(expr),
        global(global) {}

      const cb::SmartPointer<VariableExpr> &getVariable() const {return var;}
      const indices_t &getIndices() const {return indices;}
      const cb::SmartPointer<Expression> &getExpression() const {return expr;}
      bool isGlobal() const {return global;}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
   };
  }
}

#endif // OPENSCAM_TPL_ASSIGN_STMT_H

