#ifndef OPENSCAM_TPL_BINARY_EXPR_H
#define OPENSCAM_TPL_BINARY_EXPR_H

#include "Expression.h"

namespace OpenSCAM {
  namespace TPL {
    class BinaryExpr : public Expression {
      cb::SmartPointer<Expression> left;
      cb::SmartPointer<Expression> right;

    public:
      BinaryExpr(TPLID type, const cb::SmartPointer<Expression> &left,
                 const cb::SmartPointer<Expression> &right) :
        Expression(type), left(left), right(right) {}

      const cb::SmartPointer<Expression> &getLeft() const {return left;}
      const cb::SmartPointer<Expression> &getRight() const {return right;}

      // From Expression
      bool isConstant() const
      {return left->isConstant() && right->isConstant();}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_BINARY_EXPR_H

