#ifndef OPENSCAM_TPL_CALL_EXPR_H
#define OPENSCAM_TPL_CALL_EXPR_H

#include "Expression.h"
#include "Declaration.h"

#include <vector>
#include <string>
#include <utility>


namespace OpenSCAM {
  namespace TPL {
    class CallExpr :
      public Expression,
      public std::vector<std::pair<std::string,
                                   cb::SmartPointer<Expression> > > {
      cb::SmartPointer<Name> name;
      cb::SmartPointer<Declaration> decl;

    public:
      typedef std::pair<std::string, cb::SmartPointer<Expression> > pair_t;

      CallExpr(const cb::SmartPointer<Name> &name,
               const cb::SmartPointer<Declaration> &decl) :
        Expression(TPLID_CALL), name(name), decl(decl) {}

      const cb::SmartPointer<Name> &getName() const {return name;}
      const cb::SmartPointer<Declaration> &getDeclaration() const {return decl;}

      // From Expression
      bool isConstant() const {return false;}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_CALL_EXPR_H

