#ifndef OPENSCAM_TPL_CASE_STMT_H
#define OPENSCAM_TPL_CASE_STMT_H

#include "Statement.h"
#include "Constant.h"


namespace OpenSCAM {
  namespace TPL {
    class CaseStmt : public Statement {
    public:
      typedef std::vector<cb::SmartPointer<Expression> > exprs_t;

    private:
      exprs_t exprs;
      cb::SmartPointer<Statement> stmt;

    public:
      CaseStmt(const exprs_t &exprs, const cb::SmartPointer<Statement> stmt) :
        Statement(TPLID_CASE), exprs(exprs), stmt(stmt) {}

      const exprs_t &getExpressions() const {return exprs;}
      const cb::SmartPointer<Statement> &getStatement() const {return stmt;}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_CASE_STMT_H

