#ifndef OPENSCAM_TPL_CONSTANT_H
#define OPENSCAM_TPL_CONSTANT_H

#include "Expression.h"

#include <openscam/tpl/type/Value.h>


namespace OpenSCAM {
  namespace TPL {
    class Constant : public Expression {
      cb::SmartPointer<Value> value;
      std::string text;

    public:
      Constant(const cb::SmartPointer<Value> &value, const std::string &text) :
        Expression(TPLID_CONSTANT), value(value), text(text) {}

      const cb::SmartPointer<Value> &getValue() const {return value;}
      const std::string &getText() const {return text;}

      // From Expression
      bool isConstant() const {return true;}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_CONSTANT_H

