#ifndef OPENSCAM_TPL_CONSTANT_DECL_H
#define OPENSCAM_TPL_CONSTANT_DECL_H

#include "Declaration.h"

namespace OpenSCAM {
  namespace TPL {
    class ConstantDecl : public Declaration {
      std::string name;
      cb::SmartPointer<Expression> expr;
      cb::SmartPointer<Value> value;

    public:
      ConstantDecl(const std::string &name,
                   const cb::SmartPointer<Expression> &expr) :
        Declaration(TPLID_CONSTANT), name(name), expr(expr) {}

      ConstantDecl(const std::string &name,
                   const cb::SmartPointer<Value> &value) :
        Declaration(TPLID_CONSTANT), name(name), value(value) {}

      std::string getName() const {return name;}
      const cb::SmartPointer<Expression> &getExpression() const {return expr;}
      void setValue(const cb::SmartPointer<Value> &value) {this->value = value;}

      // From Declaration
      bool isConstant() const {return true;}
      const cb::SmartPointer<Value> &getValue() const {return value;}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_CONSTANT_DECL_H

