#ifndef OPENSCAM_TPL_DECLARATION_H
#define OPENSCAM_TPL_DECLARATION_H

#include "ASTNode.h"

#include "../type/Value.h"

namespace OpenSCAM {
  namespace TPL {
    class Environment;

    class Declaration : public ASTNode {
    public:
      Declaration(TPLID type) : ASTNode(type) {}

      virtual bool isConstant() const {return false;}
      virtual const cb::SmartPointer<Value> &getValue() const
      {THROWS("Cannot get value from " << getType());}
      virtual int getIndex() const
      {THROWS("Cannot get index of " << getType());}
      virtual void setIndex(int index)
      {THROWS("Cannot set index of " << getType());}
      virtual int getEnvID() const
      {THROWS("Cannot get environment ID of " << getType());}
      virtual void setEnvID(int id)
      {THROWS("Cannot set environment ID of " << getType());}
      virtual const cb::SmartPointer<Environment> &getEnvironment() const
      {THROWS("Cannot get environment from " << getType());}
      virtual const cb::SmartPointer<BlockStmt> &getBlock() const
      {THROWS("Cannot get block from " << getType());}
    };
  }
}

#endif // OPENSCAM_TPL_DECLARATION_H

