#ifndef OPENSCAM_TPL_DO_STMT_H
#define OPENSCAM_TPL_DO_STMT_H

#include "Statement.h"
#include "Expression.h"


namespace OpenSCAM {
  namespace TPL {
    class DoStmt : public Statement {
      cb::SmartPointer<Statement> stmt;
      cb::SmartPointer<Expression> expr;

    public:
      DoStmt(const cb::SmartPointer<Statement> &stmt,
             const cb::SmartPointer<Expression> &expr) :
        Statement(TPLID_DO), stmt(stmt), expr(expr) {}

      const cb::SmartPointer<Statement> &getStatement() const {return stmt;}
      const cb::SmartPointer<Expression> &getExpression() const {return expr;}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_DO_STMT_H

