#ifndef OPENSCAM_TPL_EXPRESSION_STMT_H
#define OPENSCAM_TPL_EXPRESSION_STMT_H

#include "Statement.h"
#include "Expression.h"


namespace OpenSCAM {
  namespace TPL {
    class ExpressionStmt : public Statement {
      cb::SmartPointer<Expression> expr;

    public:
      ExpressionStmt(const cb::SmartPointer<Expression> &expr) :
        Statement(expr->getType()), expr(expr) {}

      const cb::SmartPointer<Expression> &getExpression() const {return expr;}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_EXPRESSION_STMT_H

