#ifndef OPENSCAM_TPL_FOR_STMT_H
#define OPENSCAM_TPL_FOR_STMT_H

#include "Statement.h"
#include "Expression.h"
#include "AssignStmt.h"

#include <vector>


namespace OpenSCAM {
  namespace TPL {
    class ForStmt : public Statement {
      cb::SmartPointer<AssignStmt> init;
      cb::SmartPointer<Expression> condition;
      cb::SmartPointer<AssignStmt> increment;
      cb::SmartPointer<Statement> stmt;

    public:
      ForStmt(const cb::SmartPointer<AssignStmt> &init,
              const cb::SmartPointer<Expression> &condition,
              const cb::SmartPointer<AssignStmt> &increment,
              const cb::SmartPointer<Statement> &stmt) :
        Statement(TPLID_FOR), init(init), condition(condition),
        increment(increment), stmt(stmt) {}

      const cb::SmartPointer<AssignStmt> &getInit() const {return init;}
      const cb::SmartPointer<Expression> &getCondition() const
      {return condition;}
      const cb::SmartPointer<AssignStmt> &getIncrement() const
      {return increment;}
      const cb::SmartPointer<Statement> &getStatement() const {return stmt;}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_FOR_STMT_H

