#include "FunctionDecl.h"

#include "../Context.h"
#include "../Interpreter.h"
#include "../type/NullValue.h"
#include "../SmartStackFrame.h"

using namespace cb;
using namespace OpenSCAM::TPL;


SmartPointer<Value> FunctionDecl::call(Context &ctx, const Arguments &args) {
  // Setup stack frame
  SmartStackFrame smartStackFrame(ctx, *getEnvironment());
  VectorValue &frame = *ctx.getCurrentFrame();

  // Set args in frame
  for (unsigned i = 0; i < size(); i++) frame[i] = args[i];

  // Run the code
  try {
    Interpreter interpreter(ctx);
    getBlock()->interpret(interpreter);
  } catch (const SmartPointer<Value> &ret) {
    return ret;
  }

  return NullValue::instance();
}
