#ifndef OPENSCAM_TPL_FUNCTION_DECL_H
#define OPENSCAM_TPL_FUNCTION_DECL_H

#include "NamespaceDecl.h"
#include "ArgumentDecls.h"

#include "../Function.h"


namespace OpenSCAM {
  namespace TPL {
    class FunctionDecl :
      public Function, public NamespaceDecl, public ArgumentDecls {
      bool variableArgs;

    public:
      FunctionDecl(const std::string &name,
                   const cb::SmartPointer<Environment> &env = new Environment,
                   const cb::SmartPointer<BlockStmt> &block = 0,
                   bool variableArgs = false) :
        NamespaceDecl(name, env, block, TPLID_FUNCTION),
        variableArgs(variableArgs) {}

      bool getVariableArgs() const {return variableArgs;}
      void setVariableArgs(bool x) {variableArgs = x;}

      // From Function
      cb::SmartPointer<Value> call(Context &ctx, const Arguments &args);

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_FUNCTION_DECL_H

