#ifndef OPENSCAM_TPL_IF_STMT_H
#define OPENSCAM_TPL_IF_STMT_H

#include "Statement.h"
#include "Expression.h"


namespace OpenSCAM {
  namespace TPL {
    class IfStmt : public Statement {
      cb::SmartPointer<Expression> expr;
      cb::SmartPointer<Statement> ifStmt;
      cb::SmartPointer<Statement> elseStmt;

    public:
      IfStmt(const cb::SmartPointer<Expression> &expr,
             const cb::SmartPointer<Statement> &ifStmt,
             const cb::SmartPointer<Statement> &elseStmt) :
        Statement(TPLID_IF), expr(expr), ifStmt(ifStmt), elseStmt(elseStmt) {}

      const cb::SmartPointer<Expression> &getExpression() const {return expr;}
      const cb::SmartPointer<Statement> &getIfStmt() const {return ifStmt;}
      const cb::SmartPointer<Statement> &getElseStmt() const {return elseStmt;}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_IF_STMT_H

