#ifndef OPENSCAM_TPL_IMPORT_DECL_H
#define OPENSCAM_TPL_IMPORT_DECL_H

#include "NamespaceDecl.h"
#include "Name.h"

#include <openscam/tpl/Module.h>


namespace OpenSCAM {
  namespace TPL {
    class Interpreter;

    class ImportDecl : public Declaration {
      std::string name;
      std::string id;
      std::string as;
      cb::SmartPointer<Module> module;

    public:
      ImportDecl(const std::string &name, const std::string &id,
                 const std::string &as,
                 const cb::SmartPointer<Module> &module) :
        Declaration(TPLID_IMPORT), name(name), id(id), as(as), module(module) {}

      const std::string &getID() const {return id;}
      const std::string &getAs() const {return as;}

      void init(Interpreter &interpreter) {module->init(interpreter);}

      // From Declaration
      std::string getName() const {return name;}
      const cb::SmartPointer<Environment> &getEnvironment() const
      {return module->getEnvironment();}
      const cb::SmartPointer<BlockStmt> &getBlock() const
      {return module->getBlock();}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_IMPORT_DECL_H

