#ifndef OPENSCAM_TPL_NAME_H
#define OPENSCAM_TPL_NAME_H

#include "ASTNode.h"
#include "../Token.h"

#include <ostream>


namespace OpenSCAM {
  namespace TPL {
    class Name : public ASTNode {
      std::vector<std::string> name;
      std::vector<Token> tokens;

    public:
      const std::vector<std::string> &getName() const {return name;}
      const std::vector<Token> &getTokens() const {return tokens;}

      std::string toString() const;
      void print(std::ostream &stream) const {stream << toString();}

      void append(const std::string &part) {name.push_back(part);}
      void append(const Token &token);

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };


    static inline
    std::ostream &operator<<(std::ostream &stream, const Name &name) {
      name.print(stream);
      return stream;
    }
  }
}

#endif // OPENSCAM_TPL_NAME_H

