#ifndef OPENSCAM_TPL_NAMESPACE_DECL_H
#define OPENSCAM_TPL_NAMESPACE_DECL_H

#include "Declaration.h"
#include "BlockStmt.h"

#include "../Environment.h"


namespace OpenSCAM {
  namespace TPL {
    class NamespaceDecl : public Declaration {
      std::string name;
      cb::SmartPointer<Environment> env;
      cb::SmartPointer<BlockStmt> block;

    public:
      NamespaceDecl(const std::string &name,
                    const cb::SmartPointer<Environment> &env,
                    const cb::SmartPointer<BlockStmt> &block, TPLID type) :
        Declaration(type), name(name), env(env), block(block) {}

      void setBlock(const cb::SmartPointer<BlockStmt> &block)
      {this->block = block;}

      // From Declaration
      std::string getName() const {return name;}
      const cb::SmartPointer<Environment> &getEnvironment() const {return env;}
      const cb::SmartPointer<BlockStmt> &getBlock() const {return block;}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_NAMESPACE_DECL_H

