#ifndef OPENSCAM_TPL_QUOTED_EXPR_H
#define OPENSCAM_TPL_QUOTED_EXPR_H

#include "Expression.h"

namespace OpenSCAM {
  namespace TPL {
    class QuotedExpr : public Expression {
      cb::SmartPointer<Expression> expr;

    public:
      QuotedExpr(const cb::SmartPointer<Expression> &expr) :
        Expression(TPLID_QUOTED_EXPR), expr(expr) {}

      const cb::SmartPointer<Expression> &getExpression() const {return expr;}

      // From Expression
      bool isConstant() const {return expr->isConstant();}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_QUOTED_EXPR_H

