#ifndef OPENSCAM_TPL_SLICE_EXPR_H
#define OPENSCAM_TPL_SLICE_EXPR_H

#include "Expression.h"

namespace OpenSCAM {
  namespace TPL {
    class SliceExpr : public Expression {
      cb::SmartPointer<Expression> expr;
      cb::SmartPointer<Expression> start;
      cb::SmartPointer<Expression> end;

    public:
      SliceExpr(const cb::SmartPointer<Expression> &expr,
                const cb::SmartPointer<Expression> &start,
                const cb::SmartPointer<Expression> &end) :
        Expression(TPLID_SLICE), expr(expr), start(start), end(end) {}

      const cb::SmartPointer<Expression> &getExpression() const {return expr;}
      const cb::SmartPointer<Expression> &getStart() const {return start;}
      const cb::SmartPointer<Expression> &getEnd() const {return end;}

      // From Expression
      bool isConstant() const {
        return expr->isConstant() && start->isConstant() &&
          (end.isNull() || end->isConstant());
      }

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_SLICE_EXPR_H

