#ifndef OPENSCAM_TPL_SWITCH_STMT_H
#define OPENSCAM_TPL_SWITCH_STMT_H

#include "Statement.h"
#include "Expression.h"
#include "CaseStmt.h"

#include <vector>


namespace OpenSCAM {
  namespace TPL {
    class SwitchStmt :
      public Statement, public std::vector<cb::SmartPointer<CaseStmt> > {
      cb::SmartPointer<Expression> expr;
      cb::SmartPointer<Statement> defaultStmt;

    public:
      SwitchStmt(const cb::SmartPointer<Expression> &expr) :
        Statement(TPLID_SWITCH), expr(expr) {}

      const cb::SmartPointer<Expression> &getExpression() const {return expr;}

      const cb::SmartPointer<Statement> &getDefault() const
      {return defaultStmt;}
      void setDefault(const cb::SmartPointer<Statement> &stmt)
      {defaultStmt = stmt;}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_SWITCH_STMT_H

