#ifndef OPENSCAM_TPL_UNARY_EXPR_H
#define OPENSCAM_TPL_UNARY_EXPR_H

#include "Expression.h"

namespace OpenSCAM {
  namespace TPL {
    class UnaryExpr : public Expression {
      cb::SmartPointer<Expression> expr;

    public:
      UnaryExpr(TPLID type, const cb::SmartPointer<Expression> &expr) :
        Expression(type), expr(expr) {}

      const cb::SmartPointer<Expression> &getExpression() const {return expr;}

      // From Expression
      bool isConstant() const {return expr->isConstant();}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_UNARY_EXPR_H

