#ifndef OPENSCAM_TPL_VARIABLE_DECL_H
#define OPENSCAM_TPL_VARIABLE_DECL_H

#include "Declaration.h"


namespace OpenSCAM {
  namespace TPL {
    class VariableDecl : public Declaration {
      std::string name;
      int index;
      int envID;

    public:
      VariableDecl(const std::string &name) :
        Declaration(TPLID_VARIABLE), name(name), index(-1), envID(-1) {}

      std::string getName() const {return name;}

      // From Declaration
      int getIndex() const {return index;}
      void setIndex(int index) {this->index = index;}
      int getEnvID() const {return envID;}
      void setEnvID(int envID) {this->envID = envID;}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_VARIABLE_DECL_H

