#ifndef OPENSCAM_TPL_VARIABLE_EXPR_H
#define OPENSCAM_TPL_VARIABLE_EXPR_H

#include "Expression.h"
#include "Declaration.h"
#include "Name.h"


namespace OpenSCAM {
  namespace TPL {
    class VariableExpr : public Expression {
      cb::SmartPointer<Name> name;
      cb::SmartPointer<Declaration> decl;

    public:
      VariableExpr(const cb::SmartPointer<Name> &name,
                   const cb::SmartPointer<Declaration> &decl) :
        Expression(TPLID_VARIABLE_EXPR), name(name), decl(decl) {}

      const cb::SmartPointer<Name> &getName() const {return name;}
      const cb::SmartPointer<Declaration> &getDeclaration() const {return decl;}

      // From Expression
      bool isConstant() const {return decl->isConstant();}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_VARIABLE_EXPR_H

