#ifndef OPENSCAM_TPL_VECTOR_EXPR_H
#define OPENSCAM_TPL_VECTOR_EXPR_H

#include "Expression.h"

namespace OpenSCAM {
  namespace TPL {
    class VectorExpr :
      public Expression, public std::vector<cb::SmartPointer<Expression> > {

    public:
      VectorExpr() : Expression(TPLID_VECTOR) {}

      // From Expression
      bool isConstant() const {
        for (unsigned i = 0; i < size(); i++)
          if (!at(i)->isConstant()) return false;
        return true;
      }

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_VECTOR_EXPR_H

