#ifndef OPENSCAM_TPL_WHILE_STMT_H
#define OPENSCAM_TPL_WHILE_STMT_H

#include "Statement.h"
#include "Expression.h"


namespace OpenSCAM {
  namespace TPL {
    class WhileStmt : public Statement {
      cb::SmartPointer<Expression> expr;
      cb::SmartPointer<Statement> stmt;

    public:
      WhileStmt(const cb::SmartPointer<Expression> &expr,
                const cb::SmartPointer<Statement> &stmt) :
        Statement(TPLID_WHILE), expr(expr), stmt(stmt) {}

      const cb::SmartPointer<Expression> &getExpression() const {return expr;}
      const cb::SmartPointer<Statement> &getStatement() const {return stmt;}

      // From ASTNode
      OPENSCAM_TPL_AST_NODE_VISITORS;
    };
  }
}

#endif // OPENSCAM_TPL_WHILE_STMT_H

