#ifndef OPENSCAM_TPL_BUILTIN_FUNCTION_PTR_H
#define OPENSCAM_TPL_BUILTIN_FUNCTION_PTR_H

#include "BuiltinFunction.h"

namespace OpenSCAM {
  namespace TPL {
    class BuiltinFunctionPtr : public BuiltinFunction {
    public:
      typedef cb::SmartPointer<Value> (*function_t)(Context &ctx,
                                                    const Arguments &args);

    protected:
      function_t function;

    public:
      BuiltinFunctionPtr(function_t function, const std::string &name,
                         const std::string &args) :
        BuiltinFunction(name, args), function(function) {}

      // From Function
      cb::SmartPointer<Value> call(Context &ctx, const Arguments &args)
      {return function(ctx, args);}
    };
  }
}

#endif // OPENSCAM_TPL_BUILTIN_FUNCTION_PTR_H

