#ifndef OPENSCAM_TPL_MATH_LIBRARY_H
#define OPENSCAM_TPL_MATH_LIBRARY_H

#include <openscam/tpl/Module.h>


namespace OpenSCAM {
  namespace TPL {
    class MathLibrary : public Module {
    public:
      MathLibrary();

      OPENSCAM_TPL_DEFINE_FUNC(near);
      OPENSCAM_TPL_DEFINE_FUNC(min);
      OPENSCAM_TPL_DEFINE_FUNC(max);

      // math.h
      OPENSCAM_TPL_DEFINE_FUNC(acos);
      OPENSCAM_TPL_DEFINE_FUNC(asin);
      OPENSCAM_TPL_DEFINE_FUNC(atan);
      OPENSCAM_TPL_DEFINE_FUNC(atan2);
      OPENSCAM_TPL_DEFINE_FUNC(cos);
      OPENSCAM_TPL_DEFINE_FUNC(cosh);
      OPENSCAM_TPL_DEFINE_FUNC(sin);
      OPENSCAM_TPL_DEFINE_FUNC(sinh);
      OPENSCAM_TPL_DEFINE_FUNC(tan);
      OPENSCAM_TPL_DEFINE_FUNC(tanh);
      OPENSCAM_TPL_DEFINE_FUNC(exp);
      OPENSCAM_TPL_DEFINE_FUNC(log);
      OPENSCAM_TPL_DEFINE_FUNC(log10);
      OPENSCAM_TPL_DEFINE_FUNC(pow);
      OPENSCAM_TPL_DEFINE_FUNC(sqrt);
      OPENSCAM_TPL_DEFINE_FUNC(ceil);
      OPENSCAM_TPL_DEFINE_FUNC(fabs);
      OPENSCAM_TPL_DEFINE_FUNC(floor);
      OPENSCAM_TPL_DEFINE_FUNC(fmod);
      OPENSCAM_TPL_DEFINE_FUNC(round);
    };
  }
}

#endif // OPENSCAM_TPL_MATH_LIBRARY_H

