#ifndef OPENSCAM_TPL_BOOL_VALUE_H
#define OPENSCAM_TPL_BOOL_VALUE_H

#include "Value.h"

namespace OpenSCAM {
  namespace TPL {
    class BoolValue : public Value {
      bool value;

    public:
      BoolValue(bool value) : value(value) {}

      bool getValue() const {return value;}

      // From Value
      TPLID getType() const {return TPLID_BOOL;}
      bool toBool() const {return value;}
      bool equal(const Value &value) const
      {return this->value == value.toBool();}
    };
  }
}

#endif // OPENSCAM_TPL_BOOL_VALUE_H

