#include "FloatValue.h"

#include <cbang/Exception.h>

using namespace cb;
using namespace OpenSCAM::TPL;


bool FloatValue::equal(const Value &value) const {
  if (value.getType() == TPLID_NULL) return this->value == 0;

  if (!value.isNumber())
    THROWS("Cannot compare number to " << value.getType());

  return this->value == value.toFloat();
}


bool FloatValue::less(const Value &value) const {
  if (!value.isNumber())
    THROWS("Cannot compare number to " << value.getType());

  return this->value < value.toFloat();
}
