#ifndef OPENSCAM_TPL_FLOAT_VALUE_H
#define OPENSCAM_TPL_FLOAT_VALUE_H

#include "Value.h"

namespace OpenSCAM {
  namespace TPL {
    class FloatValue : public Value {
      double value;

    public:
      FloatValue(double value) : value(value) {}

      double getValue() const {return value;}

      // From Value
      TPLID getType() const {return TPLID_FLOAT;}
      bool toBool() const {return value;}
      int32_t toInteger() const {return (int32_t)value;}
      double toFloat() const {return value;}
      bool equal(const Value &value) const;
      bool less(const Value &value) const;
    };
  }
}

#endif // OPENSCAM_TPL_FLOAT_VALUE_H

