#include "IntegerValue.h"

#include <cbang/Exception.h>

using namespace cb;
using namespace OpenSCAM::TPL;


bool IntegerValue::equal(const Value &value) const {
  if (value.getType() == TPLID_NULL) return this->value == 0;

  if (!value.isNumber())
    THROWS("Cannot compare number to " << value.getType());

  if (value.isFloat()) return toFloat() == value.toFloat();
  return this->value == value.toInteger();
}


bool IntegerValue::less(const Value &value) const {
  if (!value.isNumber())
    THROWS("Cannot compare integer to " << value.getType());

  if (value.isFloat()) return toFloat() < value.toFloat();
  return this->value < value.toInteger();
}
