#ifndef OPENSCAM_TPL_INTEGER_VALUE_H
#define OPENSCAM_TPL_INTEGER_VALUE_H

#include "Value.h"

namespace OpenSCAM {
  namespace TPL {
    class IntegerValue : public Value {
      int32_t value;

    public:
      IntegerValue(int32_t value) : value(value) {}

      int32_t getValue() const {return value;}

      // From Value
      TPLID getType() const {return TPLID_INTEGER;}
      bool toBool() const {return value;}
      int32_t toInteger() const {return value;}
      double toFloat() const {return value;}
      bool equal(const Value &value) const;
      bool less(const Value &value) const;
    };
  }
}

#endif // OPENSCAM_TPL_INTEGER_VALUE_H

