#ifndef OPENSCAM_TPL_NULL_VALUE_H
#define OPENSCAM_TPL_NULL_VALUE_H

#include "Value.h"

namespace OpenSCAM {
  namespace TPL {
    class NullValue : public Value {
      static cb::SmartPointer<Value> singleton;

      NullValue() {}
    public:

      static const cb::SmartPointer<Value> &instance();

      // From Value
      TPLID getType() const {return TPLID_NULL;}
      bool toBool() const {return false;}
      bool equal(const Value &value) const {return !value.toBool();}
    };
  }
}

#endif // OPENSCAM_TPL_NULL_VALUE_H

