#ifndef OPENSCAM_TPL_STRING_VALUE_H
#define OPENSCAM_TPL_STRING_VALUE_H

#include "Value.h"

#include <string>


namespace OpenSCAM {
  namespace TPL {
    class StringValue : public Value {
      std::string value;

    public:
      StringValue(const std::string &value) : value(value) {}

      // From Value
      TPLID getType() const {return TPLID_STRING;}

      const std::string &getValue() const {return value;}
      bool toBool() const {return !value.empty();}
      const std::string &toString() const {return value;}
      bool equal(const Value &value) const;
   };
  }
}

#endif // OPENSCAM_TPL_STRING_VALUE_H

