#include "Value.h"

#include "NullValue.h"
#include "BoolValue.h"
#include "IntegerValue.h"
#include "FloatValue.h"
#include "StringValue.h"

using namespace std;
using namespace OpenSCAM::TPL;


void Value::appendNull() {
  append(NullValue::instance());
}


void Value::appendBool(bool value) {
  append(new BoolValue(value));
}


void Value::appendInteger(int32_t value) {
  append(new IntegerValue(value));
}


void Value::appendFloat(double value) {
  append(new FloatValue(value));
}


void Value::appendString(const string &value) {
  append(new StringValue(value));
}
