#include "VectorValue.h"

#include <cbang/Exception.h>

using namespace cb;
using namespace OpenSCAM::TPL;


bool VectorValue::equal(const Value &value) const {
  if (value.isNull()) return empty();

  if (!value.isVector())
    THROWS("Cannot compare vector to " << value.getType());

  const VectorValue &vector = *dynamic_cast<const VectorValue *>(&value);
  if (size() != vector.size()) return false;

  for (unsigned i = 0; i < size(); i++)
    if (!at(i)->equal(*vector[i])) return false;

  return true;
}
