#ifndef OPENSCAM_TPL_VECTOR_VALUE_H
#define OPENSCAM_TPL_VECTOR_VALUE_H

#include "Value.h"

#include <cbang/SmartPointer.h>


namespace OpenSCAM {
  namespace TPL {
    class VectorValue :
      public Value, public std::vector<cb::SmartPointer<Value> > {
    public:
      typedef std::vector<cb::SmartPointer<Value> > Super_T;
      VectorValue(unsigned size = 0) : Super_T(size) {}

      // From Value
      TPLID getType() const {return TPLID_VECTOR;}
      void append(const cb::SmartPointer<Value> &value) {push_back(value);}
      bool toBool() const {return !empty();}
      const std::vector<cb::SmartPointer<Value> > &toVector() const
      {return *this;}
      bool equal(const Value &value) const;
    };
  }
}

#endif // OPENSCAM_TPL_VECTOR_VALUE_H

