/******************************************************************************\

    OpenSCAM is an Open-Source CAM software.
    Copyright (C) 2011-2012 Joseph Coffland <joseph@cauldrondevelopment.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\******************************************************************************/

#ifndef OPENSCAM_TRAN_H
#define OPENSCAM_TRAN_H

#include <openscam/gcode/Printer.h>

#include <openscam/sim/Axes.h>
#include <openscam/gcode/Evaluator.h>

#include <cbang/io/Reader.h>

#include <string>
#include <set>

namespace cb {class Options;}

namespace OpenSCAM {
  class Tran : public Printer, public cb::Reader {
    cb::Options &options;
    Axes tran;
    Axes scale;
    cb::Vector<3, bool> flip;
    cb::Vector3D flipOffset;
    Evaluator eval;
    bool axisSwap[3];

  public:
    Tran(cb::Options &options, std::ostream &stream);

    void init();

    // From cb::Reader
    void read(const cb::InputSource &source);

    void tranWord(Word *word, unsigned axis);
    void scaleWord(Word *word, unsigned axis);
    void flipWord(Word *word, double offset);

    // From Processor
    void operator()(const cb::SmartPointer<Block> &block);
  };
}

#endif // OPENSCAM_TRAN_H
