/******************************************************************************\

    OpenSCAM is an Open-Source CAM software.
    Copyright (C) 2011-2012 Joseph Coffland <joseph@cauldrondevelopment.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\******************************************************************************/

#ifndef OPENSCAM_STRING_FORMATTER_H
#define OPENSCAM_STRING_FORMATTER_H

#include "ValueFormatter.h"

namespace OpenSCAM {
  class StringFormatter : public ValueFormatter {
    std::string formatStr;

  public:
    StringFormatter(const std::string &formatStr) : formatStr(formatStr) {}

    static std::string doFormat(const char *fmt, ...);

    // From ValueFormatter
    using ValueFormatter::format;
    std::string format(const std::string &x)
    {return doFormat(formatStr.c_str(), x.c_str());}
    std::string format(int64_t x) {return doFormat(formatStr.c_str(), x);}
    std::string format(double x) {return doFormat(formatStr.c_str(), x);}
    std::string format(bool x) {return doFormat(formatStr.c_str(), x);}
  };
}

#endif // OPENSCAM_STRING_FORMATTER_H

