/******************************************************************************\

    OpenSCAM is an Open-Source CAM software.
    Copyright (C) 2011-2012 Joseph Coffland <joseph@cauldrondevelopment.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\******************************************************************************/

#ifndef OPENSCAM_VALUE_FORMATTER_H
#define OPENSCAM_VALUE_FORMATTER_H

#include <cbang/String.h>
#include <cbang/StdTypes.h>


namespace OpenSCAM {
  class ValueFormatter {
  public:
    virtual ~ValueFormatter() {} // Compiler needs this

    virtual std::string format(const std::string &x) {return x;}
    virtual std::string format(int64_t x) {return cb::String(x);}
    virtual std::string format(uint64_t x) {return format((int64_t)x);}
    virtual std::string format(int32_t x) {return format((int64_t)x);}
    virtual std::string format(uint32_t x) {return format((int64_t)x);}
    virtual std::string format(int16_t x) {return format((int64_t)x);}
    virtual std::string format(uint16_t x) {return format((int64_t)x);}
    virtual std::string format(double x) {return cb::String(x);}
    virtual std::string format(float x) {return format((double)x);}
    virtual std::string format(bool x) {return cb::String(x);}
  };
}

#endif // OPENSCAM_VALUE_FORMATTER_H

