/******************************************************************************\

    OpenSCAM is an Open-Source CAM software.
    Copyright (C) 2011-2012 Joseph Coffland <joseph@cauldrondevelopment.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\******************************************************************************/

#include <cbang/Exception.h>
#include <cbang/ApplicationMain.h>

#include <openscam/Application.h>
#include <openscam/opt/Opt.h>

using namespace std;
using namespace OpenSCAM;


namespace OpenSCAM {
  class OptApp : public Application, public Opt {
  public:
    OptApp() :
      Application("OpenSCAM Optimize"), Opt(Application::options, cout) {}

    // From Appliction
    void initialize() {Opt::init();}
    using Application::init;

    // From cb::Reader
    void read(const cb::InputSource &source) {Opt::read(source);}

    // From SignalHandler
    void handleSignal(int sig) {exit(1);}
  };
}


int main(int argc, char *argv[]) {
  return cb::doApplication<OpenSCAM::OptApp>(argc, argv);
}
