/******************************************************************************\

    OpenSCAM is an Open-Source CAM software.
    Copyright (C) 2011-2012 Joseph Coffland <joseph@cauldrondevelopment.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\******************************************************************************/

#include <cbang/Exception.h>
#include <cbang/ApplicationMain.h>

#include <openscam/Application.h>
#include <openscam/tpl/Parser.h>
#include <openscam/tpl/Loader.h>
#include <openscam/tpl/PrettyPrinter.h>

#include <iostream>

using namespace std;
using namespace cb;
using namespace OpenSCAM;
using namespace OpenSCAM::TPL;


namespace OpenSCAM {
  class TPLParseApp : public Application {

  public:
    TPLParseApp() : Application("OpenSCAM TPL Parse") {}

   // From cb::Reader
    void read(const cb::InputSource &source) {
      Parser parser(new TPL::Environment, new Loader);
      PrettyPrinter(cout).print(parser.parse(source));
    }
  };
}


int main(int argc, char *argv[]) {
  return cb::doApplication<OpenSCAM::TPLParseApp>(argc, argv);
}
